Bug 561225 - Review Request: caribou - a simplified in-place on-screen keyboard
Review Request: caribou - a simplified in-place on-screen keyboard
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Parag AN(पराग)
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-02-02 23:10 EST by Ben Konrath
Modified: 2010-02-18 17:34 EST (History)
6 users (show)

See Also:
Fixed In Version: caribou-0.0.2-1.fc12
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-02-18 17:34:15 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
panemade: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ben Konrath 2010-02-02 23:10:43 EST
Spec URL: http://bagu.org/scratch/caribou.spec
SRPM URL: http://bagu.org/scratch/caribou-0.0.2-1.fc12.src.rpm
Description:
Caribou is a text entry application that currently manifests itself as
a simplified in-place on-screen keyboard.
Comment 1 Parag AN(पराग) 2010-02-03 03:45:51 EST
I tried to run this but no luck to see UI

[parag@localhost caribou]$ caribou --debug
/usr/lib/python2.6/site-packages/clutter/__init__.py:66: Warning: g_set_prgname() called multiple times
  _clutter.init()


I started gedit and focus moved to gedit but still no luck to see UI of caribou
Comment 2 Ben Konrath 2010-02-03 14:28:48 EST
That's a known issue:

https://bugzilla.gnome.org/show_bug.cgi?id=608727

You need to turn on accessibility for caribou to work.
Comment 3 Matthias Clasen 2010-02-03 16:47:00 EST
It works here, on F12. I haven't gotten it to work on rawhide yet, but that is because the at-spi2 stack is still somewhat messed up in rawhide. Should be better with at-spi2-atk-0.1.6 due out on Monday.
Comment 4 Matthias Clasen 2010-02-03 16:47:57 EST
Ben, if I am just using this with a mouse, it seems surprisingly similar to iok.
I assume they are quite different from an a11y perspective, though ?
Comment 5 Naveen Kumar 2010-02-04 08:08:03 EST
Here's an unofficial review, using the checklist from:
http://fedoraproject.org/wiki/Packaging:ReviewGuidelines

Must: 

*  MUST: rpmlint must be run on every package. The output should be posted
in the review.[1]

OUTPUT: 1 packages and 0 specfiles checked; 0 errors, 0 warnings.

OK

*  MUST: The package must be named according to the  Package Naming Guidelines .

OK.

*  MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2]

OK.

*  MUST: The package must meet the  Packaging Guidelines .

OK. + Packaging:Python ok

*  MUST: The package must be licensed with a Fedora approved license and meet the  Licensing Guidelines .

OK.

*  MUST: The License field in the package spec file must match the actual license. [3]

OK. LGPLv2+


*  MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]

OK. COPYING & README included

*  MUST: The spec file must be written in American English. [5]

OK.


*  MUST: The spec file for the package MUST be legible. [6]

OK.

*  MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the  Source URL Guidelines for how to deal with this.

OK. The md5sum of caribou-0.0.2.tar.bz2 from upstream and bugzilla source was ab0fca50e78d1e6718280e85ad126328

*  MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

OK.   Koji build successfull, Build ID:1962619 [http://koji.fedoraproject.org/koji/taskinfo?taskID=1962619]


*  MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]

OK.   Not Applicable as noarch.

*   MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

OK.

*  MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]

OK:   No gettext in BuildRequires

*  MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]

OK.   No shared library involved

*  MUST: Packages must NOT bundle copies of system libraries.[11]

OK.  Not applicable 

*  MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]


OK.   Not to be relocated


*  MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]

ok.


*  MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [14]

OK.

*  MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]


OK.


*  MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [16]

OK.


*  MUST: Each package must consistently use macros. [17]

OK.

*  MUST: The package must contain code, or permissable content. [18]

OK.


*  MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [19]

OK. 


*  MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [19]


OK.


*  MUST: Header files must be in a -devel package. [20]

NA


*  MUST: Static libraries must be in a -static package. [21]

NA

*  MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [22]

NA

*  MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [20]

NA

*  MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}  [23]

NA

*  MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[21]

OK. Does not contain any .la libtool archives.

*  MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [24] 

NOT OK, could not locate %{name}.desktop file. No explanation was given either.[Reference: http://fedoraproject.org/wiki/Packaging/Guidelines#desktop].


*  MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [25]

OK


* MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [26]

OK.


*  MUST: All filenames in rpm packages must be valid UTF-8. [27]

OK.


(SHOULD Section)


*  SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [28]

NA

*  SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [29]

NO. Not available.

*  SHOULD: The reviewer should test that the package builds in mock. [30]

NO. I did that on Koji. Build ID:1962619 [http://koji.fedoraproject.org/koji/taskinfo?taskID=1962619]


*  SHOULD: The package should compile and build into binary rpms on all supported architectures. [31]

NA. It's a noarch

*  SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.

The current app only has a keyboard running.

*  SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [32]

NA

*  SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [23]

NA

*  SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [22]


NA

*  SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [33]

NA

*  SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[34]

NA
Comment 6 Ben Konrath 2010-02-04 10:04:00 EST
(In reply to comment #4)
> Ben, if I am just using this with a mouse, it seems surprisingly similar to
> iok.
> I assume they are quite different from an a11y perspective, though ?    

There is no specific a11y stuff in caribou right now besides the 'editable text' detection used to place the window. Currently the only difference is that caribou is an in-place osk and iok is a separate window osk. We have plans to implement some more features specific to a11y users like sticky keys and word prediction.
Comment 7 Parag AN(पराग) 2010-02-05 04:05:40 EST
Review:
+ package builds in mock (rawhide i686).
koji Build =>http://koji.fedoraproject.org/koji/taskinfo?taskID=1960314
+ rpmlint is silent for SRPM and for RPM.
+ source files match upstream url (sha1sum)
f46f7271919b0473763963b869bf03a973a014ba  caribou-0.0.2.tar.bz2
+ package meets naming and packaging guidelines.
+ specfile is properly named, is cleanly written
+ Spec file is written in American English.
+ Spec file is legible.
+ dist tag is present.
+ license is open source-compatible.
+ License text is included in package.
+ %doc is present.
+ BuildRequires are proper.
+ %clean is present.
+ package installed properly.
+ Macro use appears rather consistent.
+ Package contains code, not content.
+ no headers or static libraries.
+ no .pc file present.
+ no -devel subpackage
+ no .la files.
+ no translations are available
+ Does owns the directories it creates.
+ no scriptlets present.
+ no duplicates in %files.
+ file permissions are appropriate.
+ GUI application

Suggestions:
1) Should add desktop file.

APPROVED.
Comment 8 Parag AN(पराग) 2010-02-05 04:06:29 EST
I have tested this application on F-12 only and found its working fine.
Comment 9 Ben Konrath 2010-02-12 18:18:42 EST
(In reply to comment #7)
> Suggestions:
> 1) Should add desktop file.

The idea is that Caribou will be started by the GNOME accessibility preferences dialog so a desktop shouldn't be needed. That said, I'm planning to add one in the next upstream version so I'll wait until then to include it.

> APPROVED.    

Thanks for your work on this! :-)
Comment 10 Ben Konrath 2010-02-12 18:24:30 EST
New Package CVS Request
=======================
Package Name: caribou
Short Description: text entry application
Owners: bkonrath
Branches: F-12 devel
Comment 11 Kevin Fenzi 2010-02-12 23:19:32 EST
CVS done (by process-cvs-requests.py).
Comment 12 Fedora Update System 2010-02-14 13:45:08 EST
caribou-0.0.2-1.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/caribou-0.0.2-1.fc12
Comment 13 Fedora Update System 2010-02-18 17:34:09 EST
caribou-0.0.2-1.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.